import mongoose from 'mongoose'
import * as dotenv from 'dotenv'

const envFile = process.env.NODE_ENV && process.env.NODE_ENV === 'production' ? `.env.production` : '.env.development'
dotenv.config({ path: envFile })
console.log(process.env.DB_MAIN)
import { createSigner } from 'fast-jwt'
import { ActivityUser } from 'models/ActivityUser'
;(async () => {
  try {
    const signSync = createSigner({
      key: process.env.API_TOKEN_SECRET,
    })
    const address = '0x50A8e60041A206AcaA5F844a1104896224be6F39'
    const user = await ActivityUser.findOne({ address })
    if (!user) {
      console.log('User not found')
      process.exit(0)
    }
    const token = signSync({
      id: user.id,
      address,
      activity: 'uaw_activity',
    })
    console.log(token)
  } catch (e) {
    console.log(e)
  }
  process.exit(0)
})()
