import { getModelForClass, index, modelOptions, mongoose, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { BaseModule } from './Base'

@dbconn()
@index({ user: 1 }, { unique: false })
@index({ user: 1, type: 1 }, { unique: false })
@index({ user: 1, score: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'ingame_score_record', timestamps: true },
})
class InGameScoreRecordClass extends BaseModule {
  @prop({ required: true })
  public user: string

  @prop()
  public score: number

  @prop()
  public type: string

  @prop({ type: mongoose.Schema.Types.Mixed })
  public data: any

  public toJson() {
    return {
      user: this.user,
      score: this.score,
      type: this.type,
      //@ts-ignore
      time: this.createdAt.getTime(),
    }
  }
}

export const InGameScoreRecord = getModelForClass(InGameScoreRecordClass, {
  existingConnection: InGameScoreRecordClass['db'],
})
