import { getModelForClass, index, modelOptions, mongoose, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { BaseModule } from './Base'

@dbconn()
@index({ address: 1, tokenId: 1, dateTag: 1 }, { unique: true })
@index({ address: 1, dateTag: 1 }, { unique: false })
@index({ user: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'nft_claim_record', timestamps: true },
})
class NftClaimRecordClass extends BaseModule {
  @prop()
  public address: string
  @prop()
  public user: string

  @prop()
  public tokenId: string

  @prop()
  public dateTag: string
}

export const NftClaimRecord = getModelForClass(NftClaimRecordClass, {
  existingConnection: NftClaimRecordClass['db'],
})
