import { getModelForClass, index, modelOptions, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { BaseModule } from './Base'

@dbconn()
@index({ type: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'reward_add_record', timestamps: true },
})
class RewardRecordClass extends BaseModule {
  @prop({ required: true })
  public type: number

  @prop()
  public user: string
  @prop()
  public drawTime: number
}

export const RewardRecord = getModelForClass(RewardRecordClass, { existingConnection: RewardRecordClass['db'] })
