import { ITask } from './base/ITask'
import { TaskStatusEnum } from 'models/ActivityUser'
import { ZError } from 'zutils'
import { TaskCfg } from 'models/ActivityInfo'

export default class GoogleConnect extends ITask {
  static desc = 'google connect'
  static show: boolean = true

  async execute(data: any) {
    if (!this.user.gameAccountBinded()) {
      throw new ZError(100, 'game account already binded')
    }
    const { task } = data
    if (task.status === TaskStatusEnum.RUNNING) {
      task.status = TaskStatusEnum.SUCCESS
      task.timeFinish = Date.now()
      task.data = {
        userid: this.user.googleId || this.user.emailId,
        email: this.user.googleEmail || this.user.email,
      }
      try {
        await this.user.save()
      } catch (err) {
        throw new ZError(100, 'game account already binded')
      }
      let cfg = this.activity.tasks.find((t: TaskCfg) => t.id === task.id)
      if (cfg.autoclaim) {
        try {
          await this.claimReward(task)
        } catch (err) {
          console.log(err)
        }
      }
    }
    return true
  }
}
